<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
	<title>Sensor Scaling</title>

	<link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

	<script src='../js/meti_merged.js'></script>
	<script src='../js/meti_utils.js'></script>

	<style>
		html {
			visibility: hidden;
		}

		.table td,
		.table th {
			text-align: center;
			padding: .1rem;
		}

		.delete_class,
		.add_class {
			cursor: pointer;
		}

		#delete_div {
			display: none;
		}

		#fileUpload {
			visibility: hidden;
		}

		#download_link_div {
			display: none;
		}
	</style>

</head>

<body>
	<div w3-include-html="meti_bst.html"></div>

	<div class="container">
		<div class="row">
			<main role="main" class="col-sm-12">
				<!-- <h5 class="p-1">Non linear scaling factors</h5> -->
				<div class="row">&nbsp</div>
				<div class="row">
					<div class="col border border-primary rounded">
						<!-- Enable Wifi Station Mode -->
						<div class="input-group mb-0 mt-1">
							<div id="loader_table" class="meti_loader m-1" style="width:1.5rem; height:1.5rem"></div>
							<div class="input-group-prepend">
								<div class="input-group-text">
									<input type="checkbox" id="nl_enabled">
								</div>
							</div>
							<label type="text" class="form-control">Enable non-linear scaling factors</label>
						</div>

						<div class="non_linear_settings">
							<div class="row p-1">
								<button type="button" id="button_export"
									class="btn btn-sm btn-info col m-1 nl_buttons">Export</button>
								<button type="button" id="button_import"
									class="btn btn-sm btn-primary col m-1 nl_buttons">Import</button>
								<div class="col"></div>
								<div class="col"></div>
								<div class="col"></div>
								<div class="col"></div>
								<button type="button" id="button_edit"
									class="btn btn-sm btn-danger col m-1 nl_buttons">Edit</button>
							</div>
							<div id="download_link_div"></div>
							<div class="row mr-0" id="delete_div">
								<input class="col-sm-6" type="file" id="fileUpload" accept=".csv" />
								<button type="button" id="button_zero_span" class="btn btn-xs btn-info col p-0 mr-1">Set
									Zero/Span</button>
								<button type="button" id="button_delete_all"
									class="btn btn-xs btn-danger col p-0">Delete
									All</button>
							</div>
							<form id="formID">
								<div class="row p-1">
									<div class="row ml-1 mr-1" id="scaling_table_div" style="visibility: hidden">
										<table id="scaling_table"
											class="table table-primary table-striped table-hover mb-0">
											<thead>
												<tr>
													<th scope="col" width="5%">Sl.</th>
													<th scope="col" width="12%">Level%</th>
													<th scope="col" width="12%">Value1</th>
													<th scope="col" width="12%">Value2</th>
													<th scope="col" width="12%">Value3</th>
													<th scope="col" width="12%">Value4</th>
													<th scope="col" width="12%">Value5</th>
													<th scope="col" width="8%">Delete</th>
													<th scope="col" width="8%">Add</th>
												</tr>
											</thead>
											<tbody id="scaling_table_body" class="scaling_table_data_class">
												<!-- Driver list comes here... -->
											</tbody>
										</table>
									</div>
								</div>
							</form>
							<div class="form-group row mt-4 mb-1 ml-4 mr-4 save_cancel">
								<div class="col"></div>
								<button type="button" id="button_cancel"
									class="btn btn-sm btn-warning col m-1 mr-4">Cancel</button>
								<button type="button" id="button_save"
									class="btn btn-sm btn-success col m-1 mr-4">Save</button>
								<div class="col"></div>
							</div>
						</div>
					</div>
				</div>
			</main>
		</div>
</body>
</html>

<script>
	w3IncludeHTML();

	var scaling_array = [];
	var edit_enabled = false;
	var MAX_COLUMNS = 6;

	var TANK_CUST = "0";
	var TANK_RECT = "1";
	var TANK_CYV = "2";
	var TANK_CYH = "3";

	$(document).ready(function () {
		// display all items
		document.getElementsByTagName("html")[0].style.visibility = "visible";

		$("#sel_tank_type").on("change", function () {
			img_name = "tank_cust.png";
			switch ($("#sel_tank_type").val()) {
				case TANK_CUST:
					img_name = "tank_cust.png";
					break;

				case TANK_RECT:
					img_name = "tank_rect.png";
					break;

				case TANK_CYV:
					img_name = "tank_cyv.png";
					break;

				case TANK_CYH:
					img_name = "tank_cyh.png";
					break;

				default:
					img_name = "tank_cust.png";
					break;
			}
			$("#img_tank").attr("src", "../images/" + img_name);
			show_input_params();
		});

		function show_input_params() {
			// $("#sel_height").attr("hidden","hidden");
			// $("#sel_width").attr("hidden","hidden");
			// $("#sel_diameter").attr("hidden","hidden");

			switch ($("#sel_tank_type").val()) {
				case TANK_CUST:

					break;

				case TANK_RECT:
					img_name = "tank_rect.png";
					break;

				case TANK_CYV:
					img_name = "tank_cyv.png";
					break;

				case TANK_CYH:
					img_name = "tank_cyh.png";
					break;

				default:
					img_name = "tank_cust.png";
					break;
			}
		}

		function load_form_data() {
			$("#loader_table").css("display", "none");
			$(".save_cancel").css("display", "");

			var allTextLines = g_sensor_nl_csv.split(/\r\n|\n/);

			// first line will contain, if nl is enabled or not
			nl_enabled = parseInt(allTextLines[0]);

			if (nl_enabled == 1) {
				$('#nl_enabled').prop("checked", nl_enabled);
			}

			scaling_array = [];
			for (var i = 1; i < allTextLines.length; i++) {
				var data = allTextLines[i].split(',');

				if (data.length == MAX_COLUMNS) {
					var row = [];
					row.push(parseInt(data[0]));
					row.push(parseInt(data[1]));
					row.push(parseInt(data[2]));
					row.push(parseInt(data[3]));
					row.push(parseInt(data[4]));
					row.push(parseInt(data[5]));

					scaling_array.push(row);
				}
			}

			enable_disable();
		}

		$("#nl_enabled").on("click", function () {
			enable_disable();
		});

		function enable_disable() {
			if ($('#nl_enabled').is(":checked") == true) {
				$(".nl_buttons").attr("disabled", false);
			} else {
				$(".nl_buttons").attr("disabled", true);
			}
			edit_enabled = false;
			display_table();
			validate_scaling();
		}

		function display_table(enable_id) {
			// Narayan this has to be dynamic

			$("#scaling_table_body").html("");
			var last_idx = scaling_array.length - 1;
			$.each(scaling_array, function (idx, val) {
				var tr = $("<tr></tr>");

				var td_slno = $("<td></td>")
					.html(idx + 1)
				var td_scale = $("<td></td>")
				var td_value1 = $("<td></td>")
				var td_value2 = $("<td></td>")
				var td_value3 = $("<td></td>")
				var td_value4 = $("<td></td>")
				var td_value5 = $("<td></td>")
				var td_delete = $("<td></td>")
				var td_add = $("<td></td>")
				var td_dummy = $("<td></td>")
				var td_dummy1 = $("<td></td>")

				var obj_scale = $("<input>")
					.attr("type", "text")
					.addClass("key_value form-control form-control-sm")
					.attr("id", "scale_id_" + idx)
					.attr("value", val[0])

				var obj_value1 = $("<input>")
					.attr("type", "text")
					.addClass("key_value form-control form-control-sm")
					.attr("id", "value1_id_" + idx)
					.attr("value", val[1])

				var obj_value2 = $("<input>")
					.attr("type", "text")
					.addClass("key_value form-control form-control-sm")
					.attr("id", "value2_id_" + idx)
					.attr("value", val[2])

				var obj_value3 = $("<input>")
					.attr("type", "text")
					.addClass("key_value form-control form-control-sm")
					.attr("id", "value3_id_" + idx)
					.attr("value", val[3])

				var obj_value4 = $("<input>")
					.attr("type", "text")
					.addClass("key_value form-control form-control-sm")
					.attr("id", "value4_id_" + idx)
					.attr("value", val[4])

				var obj_value5 = $("<input>")
					.attr("type", "text")
					.addClass("key_value form-control form-control-sm")
					.attr("id", "value5_id_" + idx)
					.attr("value", val[5])

				var obj_del = $("<img>")
					.addClass("delete_class")
					.attr("src", '../images/delete.ico')
					.attr("alt", "Delete")
					.attr("data-scaling_id", idx)
					.attr("width", "24")
					.attr("height", "24")
					.attr("title", "Delete this row...")

				var obj_add = $("<img>")
					.addClass("add_class")
					.attr("src", '../images/plus.ico')
					.attr("alt", "Add")
					.attr("data-scaling_id", idx)
					.attr("width", "24")
					.attr("height", "24")
					.attr("title", "Add a row...")

				if (edit_enabled == false) {
					obj_scale.attr("disabled", "disabled")
					obj_value1.attr("disabled", "disabled")
					obj_value2.attr("disabled", "disabled")
					obj_value3.attr("disabled", "disabled")
					obj_value4.attr("disabled", "disabled")
					obj_value5.attr("disabled", "disabled")
					obj_del.css("visibility", "hidden")
					obj_add.css("visibility", "hidden")
				}

				td_scale.append(obj_scale);
				td_value1.append(obj_value1);
				td_value2.append(obj_value2);
				td_value3.append(obj_value3);
				td_value4.append(obj_value4);
				td_value5.append(obj_value5);
				td_delete.append(obj_del);
				td_add.append(obj_add);

				tr.append(td_slno);
				tr.append(td_scale);
				tr.append(td_value1);
				tr.append(td_value2);
				tr.append(td_value3);
				tr.append(td_value4);
				tr.append(td_value5);

				if (idx == 0 || idx == last_idx) {
					tr.append(td_dummy);
				} else {
					tr.append(td_delete);
				}

				if (idx == last_idx) {
					tr.append(td_dummy1);
				} else {
					tr.append(td_add);
				}

				$("#scaling_table_div").css("visibility", "visible");
				$("#scaling_table_body").append(tr);
			});

			// Scaling in First and last row should not be allowed to be edited
			min_max_disable();

			$("#button_edit").on("click", function () {
				edit_enabled = true;
				$(".key_value").removeAttr("disabled");
				min_max_disable();
				$(".delete_class").css("visibility", "visible");
				$(".add_class").css("visibility", "visible");
				$("#delete_div").css("display", "flex");
				$('#value_id_0').focus();
			});

			function min_max_disable() {
				last_idx = scaling_array.length - 1;
				$("#scale_id_0").attr("disabled", "disabled");
				$("#scale_id_" + last_idx).attr("disabled", "disabled");
			}

			// Delete
			$(".delete_class").on("click", function () {
				scaling_id = $(this).attr("data-scaling_id");
				scaling_array.splice(scaling_id, 1);

				display_table();
				validate_scaling();
			});

			// Add
			$(".add_class").on("click", function () {
				scaling_id = $(this).attr("data-scaling_id");
				scaling_array.splice(scaling_id, 0,);

				var row = [];
				row.push(scaling_array[scaling_id][0]);
				row.push(scaling_array[scaling_id][1]);

				scaling_array.splice(scaling_id, 0, row);

				display_table(scaling_id);
				validate_scaling();
			});

			$(".key_value").on("blur", function () {
				val = parseInt($(this).val());

				if (isNaN(val)) {
					val = 0;
				}
				$(this).val(val);
				validate_scaling();
			})
		}

		$("#button_export").on("click", function () {
			var csv = '';
			var file_name = "scaling_table"

			scaling_array.forEach(function (rowArray) {
				let row = rowArray.join(",");
				csv += row + "\r\n";
			});

			var csvData = 'data:application/csv;charset=utf-8,' + encodeURIComponent(csv);

			$('#download_link_div').html('<a href="' + csvData + '" target="_blank"' +
				'download="' + file_name + '.csv" class="download_csv_href_class">Click to Download</a>');

			$('.download_csv_href_class')[0].click();
		});

		$("#button_import").on("click", function () {
			// The following lines ensures that the onchange event is triggered every time
			$("#fileUpload").val('');
			$("#fileUpload").click();
		});

		$("#button_zero_span").on("click", function () {
			var last_rec = scaling_array.length - 1;
			scaling_array[0][0] = g_sensorScaling_db.zero;
			scaling_array[last_rec][0] = g_sensorScaling_db.span;

			display_table();
			validate_scaling();
		});

		$('#fileUpload').on("change", function () {
			if (typeof ($(this)[0].files[0].name) !== "undefined") {
				fileName = $(this)[0].files[0].name;
				if (fileName.endsWith(".csv")) {
					var r = confirm("Import from file - " + $(this)[0].files[0].name + " ?");
					if (r == true) {
						edit_enabled = false;
						$("#delete_div").css("display", "none");
						ImportFile();
						// display_table and validation will happen asynchronously				
					}
				} else {
					alert("Please upload a valid CSV file.");
				}
			}
		});

		$("#button_delete_all").on("click", function () {
			if (edit_enabled == true) {
				var r = confirm("Delete all scaling records?")
				if (r == true) {
					scaling_array = [];

					var row = [];
					row.push(g_sensorScaling_db.zero);
					row.push(g_sensorScaling_db.zero);
					row.push(g_sensorScaling_db.zero);
					row.push(g_sensorScaling_db.zero);
					row.push(g_sensorScaling_db.zero);
					row.push(g_sensorScaling_db.zero);
					scaling_array.push(row);

					row = [];
					row.push(g_sensorScaling_db.span);
					row.push(g_sensorScaling_db.span);
					row.push(g_sensorScaling_db.span);
					row.push(g_sensorScaling_db.span);
					row.push(g_sensorScaling_db.span);
					row.push(g_sensorScaling_db.span);
					scaling_array.push(row);

					display_table();
					$("#delete_div").css("display", "none");
				}
			}
		});

		$("#button_save").on("click", function () {
			if ($("#formID").validationEngine('validate')) {
				retVal = validate_scaling();
				if (retVal == true) {
					var r = confirm("Save Sensor Scaling configuration?");
					if (r == true) {
						save_config();
					}
				} else {
					alert("Error!!! \n\nScale and Volume should be in ascending sequence..\nThe Zero and Span Value should match the first and last Scaling value respectively... ")
				}
			}
		});

		function validate_scaling() {
			var sorted = true;

			if ($("#nl_enabled").is(":checked") == true) {
				//Updating entered values to array...
				$.each(scaling_array, function (key, value) {
					scaling_array[key][0] = $('#scale_id_' + key).val();
					scaling_array[key][1] = $('#value1_id_' + key).val();
					scaling_array[key][2] = $('#value2_id_' + key).val();
					scaling_array[key][3] = $('#value3_id_' + key).val();
					scaling_array[key][4] = $('#value4_id_' + key).val();
					scaling_array[key][5] = $('#value5_id_' + key).val();
				});


				for (var i = 0; i < scaling_array.length - 1; i++) {
					first = parseInt(scaling_array[i][0]);
					second = parseInt(scaling_array[i + 1][0]);

					nextId = i + 1;

					if (first >= second) {
						sorted = false;
						$('#scale_id_' + nextId)
							.css('background', 'red')
							.css('color', 'white')
					} else {
						$('#scale_id_' + nextId)
							.css('background', '')
							.css('color', '')
					}

					first11 = parseInt(scaling_array[i][1]);
					second11 = parseInt(scaling_array[i + 1][1]);

					if (first11 >= second11) {
						sorted = false;
						$('#value1_id_' + nextId)
							.css('background', 'red')
							.css('color', 'white')
					} else {
						$('#value1_id_' + nextId)
							.css('background', '')
							.css('color', '')
					}

					first12 = parseInt(scaling_array[i][2]);
					second12 = parseInt(scaling_array[i + 1][2]);

					if (first12 >= second12) {
						sorted = false;
						$('#value2_id_' + nextId)
							.css('background', 'red')
							.css('color', 'white')
					} else {
						$('#value2_id_' + nextId)
							.css('background', '')
							.css('color', '')
					}

					first13 = parseInt(scaling_array[i][3]);
					second13 = parseInt(scaling_array[i + 1][3]);

					if (first13 >= second13) {
						sorted = false;
						$('#value3_id_' + nextId)
							.css('background', 'red')
							.css('color', 'white')
					} else {
						$('#value3_id_' + nextId)
							.css('background', '')
							.css('color', '')
					}

					first14 = parseInt(scaling_array[i][4]);
					second14 = parseInt(scaling_array[i + 1][4]);

					if (first14 >= second14) {
						sorted = false;
						$('#value4_id_' + nextId)
							.css('background', 'red')
							.css('color', 'white')
					} else {
						$('#value4_id_' + nextId)
							.css('background', '')
							.css('color', '')
					}

					first15 = parseInt(scaling_array[i][5]);
					second15 = parseInt(scaling_array[i + 1][5]);

					if (first15 >= second15) {
						sorted = false;
						$('#value5_id_' + nextId)
							.css('background', 'red')
							.css('color', 'white')
					} else {
						$('#value5_id_' + nextId)
							.css('background', '')
							.css('color', '')
					}
				}

				// Check if first record scaling is same as zero value
				if (scaling_array[0][0] != g_sensorScaling_db.zero) {
					sorted = false;
					$('#scale_id_0')
						.css('background', 'orange')
						.css('color', 'black')
				}

				var last_rec = scaling_array.length - 1;
				// Check if last record scaling is same as span value
				if (scaling_array[last_rec][0] != g_sensorScaling_db.span) {
					sorted = false;
					$('#scale_id_' + last_rec)
						.css('background', 'orange')
						.css('color', 'black')
				}
			}
			return (sorted);
		}

		$("#button_cancel").on("click", function () {
			document.location.href = "index.html";
		});

		function downloadFile(fileName, urlData) {
			var aLink = document.createElement('a');
			var evt = document.createEvent("HTMLEvents");
			evt.initEvent("click");
			aLink.download = fileName;
			aLink.href = urlData;
			aLink.dispatchEvent(evt);
		}

		function ImportFile() {
			var fileUpload = document.getElementById("fileUpload");

			if (typeof (FileReader) != "undefined") {
				var reader = new FileReader();
				reader.onload = function (e) {
					var rows = e.target.result.split("\n");
					scaling_array = [];
					for (var i = 0; i < rows.length; i++) {
						var cells = rows[i].split(",");
						if (cells.length > 1) {
							// Narayan Add code to Reject if more than two columns
							scaling_array.push(cells);
						}
					}

					display_table();
					validate_scaling();
				}
				reader.readAsText(fileUpload.files[0]);
			} else {
				alert("This browser does not support HTML5.");
			}
		}

		function save_config() {
			var debug = 0;

			var g_sensor_nl_csv = "";

			// First line of csv file would contain whether nl is enabled...
			if ($("#nl_enabled").is(":checked") == true) {
				g_sensor_nl_csv = g_sensor_nl_csv + "1" + "\n";
			} else {
				g_sensor_nl_csv = g_sensor_nl_csv + "0" + "\n";
			}
			// Add all values to csv file...
			$.each(scaling_array, function (key, value) {
				g_sensor_nl_csv = g_sensor_nl_csv
					+ parseInt(value[0])
					+ "," + parseInt(value[1])
					+ "," + parseInt(value[2])
					+ "," + parseInt(value[3])
					+ "," + parseInt(value[4])
					+ "," + parseInt(value[5])
					+ "\n";
			});

			var data = {};

			MAX_POST_SIZE = 1000;
			var fileSize = g_sensor_nl_csv.length;
			ctr = 0;
			while (fileSize > 0) {
				start = ctr * MAX_POST_SIZE;
				end = start + MAX_POST_SIZE;
				data["scaling_file" + ctr] = g_sensor_nl_csv.substring(start, end);
				fileSize = fileSize - MAX_POST_SIZE;
				ctr++;
			}
			data['scaling_chunks'] = ctr;
			data['fileSize'] = g_sensor_nl_csv.length;

			var url = "/updateSensor_nl";
			var type = 'POST';

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					if (debug == 1) {
						console.log(response);
					}
					else {
						// console.log(js_response);
						var result = response.result;

						if (result == 1) {
							alert(response.message);
						}
						else if (result == 0) {
							alert(response.message);
						}
					}
				},
				error: function (jqXHR, exception, response) {
					alert('POST Error!');
				}
			});
		}

		function noSensorData(response) {
			console.log("POST Error...")
		}

		function updateDevicesParams(response) {
			$("#sel_clientId").val(response.dev_id);
		}
		//********* Call all start up functions after this line *******//

		setTimeout(function () {
			getDeviceParams(updateDevicesParams, noSensorData);
		}, 500);

		$("#loader_table").css("display", "block");
		$(".save_cancel").css("display", "none");

		function get_non_linear_data() {
			if (g_sensorScaling_db.pkt_ver !== undefined) {
				readSensor_nl_FromFS(load_form_data);
			} else {
				alert("Unable to load file... Try again...");
			}
		}

		var task_done = false;

		setTimeout(function () {
			if (task_done == false) {
				readSensorScalingFromFS(get_non_linear_data);
				task_done = true;
			}
		}, 1500);

		// setTimeout(function () {

		// }, 1500);
	});

</script>